struct ROM_CODE{
       BYTE FamilyCode;	   
	   BYTE SerialNumber[6];
	   BYTE CRC;
};
union ROM_Union
{
   struct ROM_CODE RomCode;
   BYTE Bytes[8];
};
struct Scratchpad{
       BYTE Tempr[2];
	   BYTE User[2];
	   BYTE Configure;
	   BYTE Byte[3];
       BYTE CRC;
};
union Scratchpad_Union
{
   struct Scratchpad Scratchpad;
   BYTE Bytes[9];
};

union ROM_Union FlashROM[SORCE];           //  
union Scratchpad_Union ScratchPad[SORCE];  //  

//   2   
//      
// 0     
// 1    . 
EEMEM union ROM_Union Flash_ROM_Union[2] ={ 0x28, 0xFD, 0x20, 0xBA, 0x01, 0x00, 0x00, 0xFF
										    ,0x28, 0x9E, 0x88, 0xBA, 0x01, 0x00, 0x00, 0x68};

void TxByte(RBYTE);
BYTE RxByte(void);
BYTE DSInit(void);
BYTE CalkCRC(RBYTE, RBYTE);
BYTE GetRomCode(union ROM_Union*);
BYTE ReadScratchpad(union Scratchpad_Union*);
BYTE CompareROMCodes(union ROM_Union*, union ROM_Union*);
void SetupDS(union ROM_Union*, union Scratchpad_Union*);





BYTE   //            .
CompareROMCodes(union ROM_Union *pCurentRom, union ROM_Union* pFlashRomCode){ 
    union ROM_Union FlashROM;
	//CurentRom.RomCode=*RomCodeP;
    eeprom_read_block(&FlashROM, pFlashRomCode,8);
	for (RBYTE i=0;i<8;i++)
	{
      if (FlashROM.Bytes[i] != pCurentRom->Bytes[i]) return(1);
	}
    return(0);
 }
void 
SetupDS(union ROM_Union* pFlashROM, union Scratchpad_Union* pScratchpad)
{
//    union Scratchpad_Union ScratchPad;
	if (DSInit())
	{
	  wdt_reset();
	   TxByte(0x55);
	   for (RBYTE y=0;y<8;y++)
  	   {
		 TxByte(pFlashROM->Bytes[y]);
       }
	   TxByte(0xBE);

	   if (ReadScratchpad(pScratchpad))
	   {  //      10 .
	    DSInit();
	   TxByte(0x55);
	   for (RBYTE y=0;y<8;y++)
  	   {
		 TxByte(pFlashROM->Bytes[y]);
       }
	      TxByte(0x4E);
		  TxByte(pScratchpad->Scratchpad.User[0]);
		  TxByte(pScratchpad->Scratchpad.User[1]);
		  TxByte(DSQUAL);
	   }
	   if (DSInit())
	   { //     
		  wdt_reset();
	   TxByte(0x55);
	   for (RBYTE y=0;y<8;y++)
  	   {
		 TxByte(FlashROM->Bytes[y]);
       }
	      TxByte(0xBE);
          ReadScratchpad(pScratchpad);
		  if (pScratchpad->Scratchpad.Configure == DSQUAL)
		  {
		    DSInit(); //      
			TxByte(0xCC);
	        TxByte(0x48);
			wdt_reset();
			_delay_ms(12);
		 }
	   }
    }
}




BYTE
DSInit(void){                                   //    
 //   
   DDR_1WARE|=1;
 //  "0"   480us 
   PORT_1WARE=0;
   _delay_us(500);
 //         1 
   wdt_reset();   	
   DDR_1WARE&=0;
   _delay_us(2);
 //      80us  ,    . 
 RBYTE i=0;
   for (; PIN_1WARE == 1 && i<=40 ;i++)
   {
        _delay_us(2);
   }
   if (PIN_1WARE== 0 && i<=40)
   {  //     1    
	   _delay_us(10);
	   while (PIN_1WARE== 0 )
	   {
          _delay_us(3);
       }
	   return (1);
   }
   return(0);
}
BYTE
CalkCRC(RBYTE shiftP, RBYTE Data){              //      

   for (RBYTE  i=0;i<8;i++) //         
   { //      XOR     
     shiftP=((shiftP)&0xFE)|(((shiftP)^Data)&1);
	 BYTE temp = 0; //        
	 temp=((shiftP)&1)<<3; //         
 	 shiftP=((shiftP)&0xE7)|(((shiftP)^(temp|(temp<<1)))&0x18);
     Data>>=1;//   1  
	 shiftP=((shiftP)>>1)|((shiftP)<<7);
	 
   } //       *shiftP     
   return(shiftP);
}

void
TxByte(RBYTE CmdByte){                          //  1   

   //   
   PORT_1WARE=1;
   DDR_1WARE|=1;
   //      0   7
   register char i=0;
   while (i < 8){
        PORT_1WARE = 0; //   0
        _delay_us(2); //   2 
		PORT_1WARE = (CmdByte&1); //   
  	    CmdByte>>=1; //    1
	    _delay_us(60); //   80 
	    PORT_1WARE = 1; //   "1"
	    _delay_us(2);
	    i++;
   }
   PORT_1WARE=1;
   DDR_1WARE|=1; //    "1"
}
BYTE
RxByte(void){                                   //  1   
DDR_1WARE&=0;
    RBYTE RxByte = 0; //   
	for(RBYTE i=0; i<8;i++)
	{
	wdt_reset();
      DDR_1WARE|=1;  //   B6  
      PORT_1WARE = 0;  //   0
	  _delay_us(2); //  >1 
	  DDR_1WARE&=0;  //   
	  _delay_us(15); //  ~15 
	  if(PIN_1WARE!=0 )  RxByte|=(1<<i);  //  1       
	  _delay_us(55); //  -
	}
	PORT_1WARE=1;
	DDR_1WARE|=1;
	return(RxByte);
}

BYTE
GetRomCode(union ROM_Union* pRomUnion){          //    
      //    ,    
      RBYTE shift = 0;
	  for (RBYTE i=0;i<7;i++)
	  {
	    pRomUnion->Bytes[i] = RxByte();
		shift=CalkCRC(shift, pRomUnion->Bytes[i]);
	  }
	  pRomUnion->RomCode.CRC = RxByte();
	  if ( pRomUnion->RomCode.CRC == shift) return(1);
	  else pRomUnion->RomCode.FamilyCode =0;
	 return(0);
}

BYTE
ReadScratchpad(union Scratchpad_Union* ScratchPad){ //    
  RBYTE shift = 0;
  for (RBYTE i=0; i<8; i++)
  {
     ScratchPad->Bytes[i] = RxByte();
	 shift=CalkCRC(shift,  ScratchPad->Bytes[i]);
  }
   ScratchPad->Scratchpad.CRC = RxByte();
  if ( ScratchPad->Scratchpad.CRC == shift) return(1);
  else
  {
    for (RBYTE i=0; i<9; i++)
    {
       ScratchPad->Bytes[i] = 0;
	}
  }
  return (0);
}