#ifndef F_CPU
#define F_CPU 16000000UL
#endif


#include <avr/io.h>
#include <avr/iom8.h>
//#include <inttypes.h> //  
#include <avr/wdt.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
 
#include "bit.h"
#include "setup.h"
#include "main.h"
#include "1Ware.h"


#if HD4780 == 162
#include "txt.h"
#include "hd4780_16x2.h"
#endif

ISR (INT1_vect)
{ 
  (*pirq_Flag1_1)=((*pTCNT2_ovf)<<8)+TCNT2;
  TCNT2=0;
  (*pTCNT2_ovf)=0;
}
ISR (TIMER2_OVF_vect)
{
  (*pTCNT2_ovf)++;
}

ISR (TIMER0_OVF_vect)
{
  #if HD4780 == 162
    BYTE register x, y=0;
  #endif 
  
  OCR1A=800 + (*pirq_Flag1_1);
  //static unsigned char i;
  static BYTE Carbsmart_disable, i;
  if (!PIND_Bit4)
  {
    _delay_ms(200);
	if (!PIND_Bit4) Carbsmart_disable = 1;
  }
  if (i ==0)  //       
  {
    if (DSInit())
    {
      TxByte(0xCC);
      TxByte(0x44);
    }
  }
  if (i == DSSPEED/2)
  {
    PORTB_Bit0=1 ;  //    
    #if HD4780 == 162
    #include "hd4780_16x2.c"
    #endif
  }
  if (i == DSSPEED) ReadDSData(); //  6   
  i++;
  if (i > DSSPEED+1) 
  {
    register BYTE Curent_Tempr=(ScratchPad[0].Scratchpad.Tempr[1]<<4) | (ScratchPad[0].Scratchpad.Tempr[0]>>4);
	PORTD&=0b00011110;
    if ( Curent_Tempr > OVERHEAT_0 )  PORTD|=0b11100001;
	else 
	{
	  if ( Curent_Tempr < OVERHEAT_0 && Curent_Tempr < CSSTART  ) PORTD_Bit5 = 1;
	  if ( (CarbSmart.Carbsmart_tempr>>4) < Curent_Tempr) PORTD_Bit6 = 1;
	}
	if ( !Carbsmart_disable )  
	{
	  #if SORCE > 0
	  #include "carbsmart.h"
	  #endif
	  PORTB_Bit0=0 ; //    
	}
	else  //          
	{
      OCR1B = CarbSmart.mServoCenter;
	  PORTD|=0b11100000;
	}
	i=0;
  }
}
void
Setup(void)	
{                                   //   
  PORTD |=0xE0;     //      
  _delay_ms(1000);  //      1  
  PORTD &=0x1F;
  
  RBYTE i=0;
  for (;i<SORCE;i++) //   2 
  {
    union ROM_Union RomUnion;
    while (PIND_Bit4) wdt_reset(); //   
	if (DSInit())                  //   
	{
	  TxByte(0x33); //   
	  if (GetRomCode((&RomUnion)))
	  {  //       
	     // c      
		 //       .
	     if (CompareROMCodes(&RomUnion, &Flash_ROM_Union[i]))
		 {
	 	   eeprom_write_block(&RomUnion,&Flash_ROM_Union[i],8);
		 }
	  }
	}
	PORTD |= (1<<(i+5)); //          
	_delay_ms(1000);
  }  
  unsigned int AD_Data=CarbSmart.mServoCenter;
  ADCSR|=(1<<ADSC); //  

  while (PIND_Bit4) //  
  {
     wdt_reset();
     _delay_us(210);
	 	 PORTD &=0b00011111;
	 PORTB &=0b11111110;
     if (ADC < 0xFF) 
	 {
	   PORTB |=1;
	   CarbSmart.Carbsmart_tempr=35;  //       35 100 110  120  .
	 }
	 if (ADC>=0xFF && ADC<0x1FF)
	 {
       PORTD |=0b00100000;
	   CarbSmart.Carbsmart_tempr=100;
	 }
     if (ADC>=0x1FF && ADC<0x2FF)
	 { 
	   PORTD |=0b01000000;
	   CarbSmart.Carbsmart_tempr=110;
	 }
	 if (ADC>=0x2FF && ADC<0x3FF) 
     {
	   PORTD |=0b10000000;
	   CarbSmart.Carbsmart_tempr=120;
	 }
  }
  CarbSmart.Carbsmart_tempr=(CarbSmart.Carbsmart_tempr<<4);
  _delay_ms(1000);
  while (PIND_Bit4) //  CarbSmart
  {
     wdt_reset();
     _delay_us(210);
     AD_Data=2100 - ( ADC>>1 );
     OCR1B=AD_Data;  
  }
  CarbSmart.mServoMax=AD_Data;
   _delay_ms(1000);
  while (PIND_Bit4) //  CarbSmart
  {
     wdt_reset();
     _delay_us(210);
     AD_Data=1196 + ( ADC>>1 );
     OCR1B=AD_Data;  
  }
  CarbSmart.mServoCenter=AD_Data;
  _delay_ms(1000);
  while (PIND_Bit4) //  CarbSmart
  {
     wdt_reset();
     _delay_us(210);
     AD_Data=CarbSmart.mServoCenter -  ( ADC>>1 );
     OCR1B=AD_Data;  
  }
  CarbSmart.mServoMin=AD_Data;  
  _delay_ms(1000); 
  while (PIND_Bit4) //  .
  {
     wdt_reset();
     _delay_us(210);
     AD_Data=CarbSmart.mServoMin +  ADC ;
     OCR1B=AD_Data;  
  }
  if (AD_Data > CarbSmart.mServoCenter) CarbSmart.Direction = 1;
  else CarbSmart.Direction = 0;
  _delay_ms(1000);
  eeprom_write_block(pCarbSmart,&eCarbSmart,10);

}

void 
ReadDSData()
{               //     
 	for (RBYTE i=0; i<SORCE; i++)
	{
	  
	  if (DSInit())
	  {
	 	  TxByte(0x55); //    2  
		  for (RBYTE y=0;y<8;y++)
		  {
		    TxByte(FlashROM[i].Bytes[y]);
		  }
		  TxByte(0xBE);
		  ReadScratchpad(&ScratchPad[i]);
	  }
	}
}

void
init_PWM()
{              //   
	//  
	ADMUX=(1<<REFS0)|(1<<REFS1);  //   
	ADCSR=(1<<ADPS0)|(1<<ADPS1)|(1<<ADPS2)|(1<<ADFR)|(1<<ADEN);  //       .
	ADCSR|=(1<<ADSC);
//------------------------------------------------------------------------------ 		    
//  0    /    PWM (1/(16/1024))*255=16.320ms 
    TIMSK = (1<<TOIE0); 
//------------------------------------------------------------------------------ 			
    
	ICR1 = 20000; //    0  ICR    0.02. 1 =1uc 
    OCR1A = CarbSmart.mServoCenter;
	OCR1B = CarbSmart.mServoCenter;
	DDRB|=0x07; //  PWM  
	TCCR1A = (1<<COM1A1) | (1<<COM1B1);//| (1<<WGM10) ;//  PWM 1   , 0   
	TCCR1B= (1<<CS11) | (1<<WGM13) ; // ICR1         /8
//------------------------------------------------------------------------------ 		
	
	MCUCR|=(1<<ISC11) | (1<<ISC10) ; // irq1   
	GICR|=(1<<INT1); // int 1     2      

	TCCR2|=(1<<CS22) |(1<<CS21) |(1<<CS20); // clock/1024 // normal overflow
//------------------------------------------------------------------------------ 		

	sei(); //  
//------------------------------------------------------------------------------ 	
#if HD4780 == 162
	while(!fv.h){wdt_reset();}                          //    
    for(BYTE j=0; j<8; j++)
    {                     //    
//	  for(BYTE i=0; i<9; i++)V2[i]=pgm_read_byte(&Spr[i+j*9]);
      iV2=0;                //    
      nV2=9;                //  9
      fv.d=0;               //    
      fv.h=0;               //  
      while(!fv.h){wdt_reset();}                        //    
    }
    _delay_ms(1000);
    fv.t=1;                 //   
    for(BYTE j=0; j<80; j++)if(!V2[j])V2[j]=32;
#endif	
//------------------------------------------------------------------------------ 

}
int 
main()
{
	#if HD4780 == 162	
	fv.s1=fv.s2=fv.t=fv.d=fv.h=0; //    
//	DDR_DATA |=(1<<DDR_DB7)|(1<<DDR_DB6)|(1<<DDR_DB5)|(1<<DDR_DB4);		//       
//	DDR_CONTROL |=(1<<DDR_E)|(1<<DDR_RS)|(1<<DDR_RW);		//       
	DDR_DATA |= 0b01111000 ;
	DDR_CONTROL |=0b00111000 ;
    #endif
	DDRB_Bit0|=1 ;
	PORTB_Bit0=1 ;
	_delay_ms(1000);
	PORTB_Bit0=0 ;
	DDRD |= 0xE0; //        
	pCarbSmart = &CarbSmart;
	eeprom_read_block(pCarbSmart,&eCarbSmart, 10);
	init_PWM();
	if (PIND_Bit4 == 0) //         
	{
	  Setup(); 
      OCR1A = pCarbSmart->mServoCenter; //  .
	  OCR1B = pCarbSmart->mServoCenter;
	}
	pirq_Flag1_1 = &irq_Flag1_1;
	pTCNT2_ovf=&TCNT2_ovf;
	//     Flash   
	for (RBYTE i=0;i<SORCE;i++)
	{
	  eeprom_read_block( &FlashROM[i],&Flash_ROM_Union[i], 8);
      //       .
  	  if ((FlashROM[i].RomCode.FamilyCode == 0)||(FlashROM[i].RomCode.FamilyCode == 0xFF))
	  {
	     PORTD |=0xE0;  //      .
	     TCCR1B= 0;
	     while(1) wdt_reset();
	  }
      SetupDS(&FlashROM[i],&ScratchPad[i]); //     
	}
    TCCR0 = (1<<CS02)| (1<<CS00); //      0     
	  	
	while(1)wdt_reset();  //      
	return(0);
}